package com.tutorialesprogramacionya.compose30

import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.compose.foundation.Canvas
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.runtime.Composable
import androidx.compose.ui.Modifier
import androidx.compose.ui.geometry.Offset
import androidx.compose.ui.geometry.Size
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.graphics.drawscope.rotate
import androidx.compose.ui.graphics.drawscope.scale
import androidx.compose.ui.graphics.drawscope.translate

class MainActivity : ComponentActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContent {
            PantallaPrincipal()
        }
    }
}

@Composable
fun PantallaPrincipal() {
    Canvas(modifier = Modifier.fillMaxSize(), onDraw = {
        val ancho = size.width
        val alto = size.height
        drawRect(
            topLeft = Offset(ancho / 2 - ancho * 0.10f, 0f),
            size = Size(ancho * 0.20f, alto * 0.20f),
            color = Color.Red
        )
        rotate(degrees = 45f) {
            drawRect(
                topLeft = Offset(ancho / 2 - ancho * 0.10f, alto / 2 - alto * 0.10f),
                size = Size(ancho * 0.20f, alto * 0.20f),
                color = Color.Green
            )
        }

        scale(scale = 0.5f) {
            drawRect(
                topLeft = Offset(ancho / 2 - ancho * 0.10f, alto - alto * 0.10f),
                size = Size(ancho * 0.20f, alto * 0.20f),
                color = Color.Blue
            )
        }
        translate(left=50f,top = 50f) {
            drawCircle(
                center = Offset(x = 0f, y = 0f),
                radius = 50f,
                color=Color.Cyan
            )
        }
    })
}
